
public class Deadlock {
	static class Friend {
        private final String name;
        
        public Friend(String name) {
            this.name = name;
        }
        public String getName() {
            return this.name;
        }
        public synchronized void inchino(Friend bower) {
            System.out.format("%s: %s" + "  si inchinato verso di me!%n", this.name, bower.getName());
            bower.restituisciInchino(this);
        }
        public synchronized void restituisciInchino(Friend bower) {
            System.out.format("%s: %s"+ " mi ha restituito l'inchino!%n",this.name, bower.getName());
        }
    }

    public static void main(String[] args) throws InterruptedException {
        final Friend agamennone =
            new Friend("Agamennone");
        final Friend menelao =
            new Friend("Menelao");
        new Thread(new Runnable() {
            public void run() { agamennone.inchino(menelao); }
        }).start();
        Thread.sleep(300);
        new Thread(new Runnable() {
            public void run() { menelao.inchino(agamennone); }
        }).start();
    }
}
